#resource_name :mycontainer

property :container_name, String, default: ''
property :data, Hash, default: {}
property :app_data_dir, String, default: ''

#property :docker_options, Hash, default: {}

action :stop do
  execute 'docker s' do
    command "docker stop #{container_name}"

    ignore_failure true
  end

end

action :destroy do

  machine container_name do
    action :destroy
  end

end


action :create do
  docker_volumes = data['docker']['volumes'] || []
  docker_ports = data['docker']['ports'] || []

  # create directories for volumes
  docker_volumes.each do |d|
    directory "#{app_data_dir}#{d}" do
      mode '0775'
      recursive true
      action :create
    end
  end

  # run container
  machine container_name do
    tag '0.1'

    action :create

    recipe recipe_provision

    #chef_environment chef_env

    # attributes
    data['attributes'].keys.each do |k|
      attribute k, data['attributes'][k]
    end


    machine_options docker_options: {
        base_image: {name: data['docker']['base_image'], repository: data['docker']['base_image'], tag: data['docker']['base_image_tag']  },
        command: data['docker']['command'] || '',
        privileged: true,
        ports: docker_ports,
        volumes: docker_volumes.map{|d| "#{app_data_dir}#{d}:#{d}"}
    }

  end
end
